module Admin
  class RolesController < ApplicationController
    before_action :authenticate_user!
    before_action :authorize_role
    before_action :set_role, only: [ :edit, :update ]

    def index
      @roles = Role.all.includes(:permissions)
    end

    def edit
      @permissions = Permission.all
    end

    def update
      if @role.update(role_params)
        redirect_to admin_roles_path, notice: "Role was successfully updated."
      else
        @permissions = Permission.all
        render :edit, status: :unprocessable_entity
      end
    end

    private

    def authorize_role
      super("events_admin")
    end

    def set_role
      @role = Role.find(params[:id])
    end

    def role_params
      params.require(:role).permit(:name, :description, permission_ids: [])
    end
  end
end
