class FetchConferenceDataJob < ApplicationJob
  queue_as :default

  def perform(conference_slug)
    conference = Conference.find_by(slug: conference_slug)
    # Convert import job class to class path format
    job_class_path = "#{conference.import_job_class.camelize}::ImportJob"
    if Object.const_defined?(job_class_path)
      job_class = job_class_path.constantize
      job_class.perform_now(conference_slug)
    else
      Rails.logger.error "No custom jobs for conference #{conference_slug} found"
    end
  rescue StandardError => e
    Rails.logger.error "Failed to enqueue job for conference #{conference_slug}: #{e.message}"
  end
end
